﻿# -*- coding: utf-8 -*-
import psyco
psyco.full()
import es, gamethread, playerlib, langlib, time, popuplib, usermsg, os, clients_reader as ma
from time import localtime, strftime
from operator import itemgetter

info = es.AddonInfo()
info.name = "[CW] Plugin" 
info.version = "1.7 Final_Beta"
info.author = "Punisher(R)" 
info.url = "http://www.universal-games.ru"
es.ServerVar('[CW] Plugin ver.', info.version).makepublic()
es.ServerVar('[CW] Plugin url', info.url).makepublic()
es.ServerVar('[CW] Plugin author', 'Punisher(R)').makepublic()

filepath = str(es.ServerVar('eventscripts_gamedir')) + "/cfg/cw_plugin/"
es.server.queuecmd("eventscripts_noisy 1")

cw_translation = langlib.Strings(es.getAddonPath("cw_plugin") + "/say.ini")

es.ServerVar("cw_rounds")
es.ServerVar("cw_show_cash")
es.ServerVar("cw_knives")
es.ServerVar("cw_overtime")
es.ServerVar("cw_record")
es.ServerVar("cw_serv_name")
es.ServerVar("cw_bell_sound")
es.ServerVar("cw_gameplay")
es.ServerVar("cw_5player_limit")
es.ServerVar("cw_team_talk")
es.ServerVar("cw_overtime_money")
es.ServerVar("cw_language")
es.ServerVar("cw_demo_dir")
es.ServerVar("cw_only_admins")
es.ServerVar("cw_overtime_round_time")
es.ServerVar("cw_spec_go_restrict")
es.ServerVar("cw_Sourcetv_kick")
es.ServerVar("cw_warmod_comtable")
es.ServerVar("cw_Sourcetv_ip")
es.ServerVar("cw_not_kick_admins")
es.ServerVar("cw_mani_admins")
es.ServerVar("cw_mani_flag")
es.ServerVar("cw_demo_name")
es.ServerVar("cw_ready_system")
es.ServerVar("cw_team_chat")

es.server.queuecmd("exec /cw_plugin/cw.cfg")

adminList = []
teamA = ["Team A","T",0,0,0,0,0]
teamB = ["Team B","CT",0,0,0,0,0]
dead_ct_List = []
dead_t_List = []
aliveT=[]
aliveCT=[]
PlayerList = []
readylist = []

def config():
	es.server.queuecmd("exec /cw_plugin/cw.cfg")
	global rounds, freezed, started, rounds_to_win, select, close, reserved, gameplay, gameplayX, Team_Talk, set_rounds
	global knives, overtime, record, readyt, readyct, played_rounds, resetcounter, serv_name, bell_sound, knive_winner, demo_name_g
	rounds = int(es.ServerVar("cw_rounds"))
	overtime = int(es.ServerVar("cw_overtime"))
	record = int(es.ServerVar("cw_record"))
	serv_name = str(es.ServerVar("cw_serv_name"))
	bell_sound = str(es.ServerVar("cw_bell_sound"))
	gameplay = int(es.ServerVar("cw_gameplay"))
	Team_Talk = int(es.ServerVar("cw_team_talk"))
	select = "admin_plugin/actions/menuselect.wav"
	close = "admin_plugin/actions/menuexit.wav"
	teamA[0] = "Team A"
	teamA[1] = "T"
	teamA[2] = teamA[3] = teamA[4] = teamA[5] = teamA[6] = 0
	teamB[0] = "Team B"
	teamB[1] = "CT"
	teamB[2] = teamB[3] = teamB[4] = teamB[5] = teamB[6] = 0
	readyt = 0
	readyct = 0
	reserved = 0
	started = 0
	freezed = 0
	set_rounds = 0
	played_rounds = 0
	resetcounter = 0
	rounds_to_win = 0
	knive_winner = 0
	demo_name_g = 0
	if int(es.ServerVar("cw_knives")) == 0:
		knives = "OFF"
	if int(es.ServerVar("cw_knives")) == 1:
		knives = "ON"
	if overtime == 0:
		overtime = "OFF"
	if record == 0:
		record = "OFF"
	if record == 1:
		record = "ON"
	if gameplay not in [1,2,3,4,5]:
		gameplay = 5
	gameplayX = str(str(gameplay) + "x" + str(gameplay))
	while len(PlayerList)>0:
		PlayerList.remove(PlayerList[0])
	while len(readylist)>0:
		readylist.remove(readylist[0])
def get_admins():
	while len(adminList) > 0:
		adminList.remove(adminList[0])
	else:
		tempsteam = open(filepath + 'admins.txt')
		for line in tempsteam:
			steam = ""
			n = 0
			line = line.strip("\n")
			if line.startswith("STEAM_"):
				while (n < len(line)):
					if line[n] not in [" ", "	", "/", "#", "\n"]:
						steam += str(line[n])
						n+=1
					else:
						n = len(line)+1
				adminList.append(steam)
		tempsteam.close
	#es.msg("#multi", "#green[CW] #default%s admins has been loaded" % len(adminList))
def downloads():
	es.stringtable('downloadables', 'sound/%s' % select)
	es.stringtable('downloadables', 'sound/%s' % close)
	es.stringtable('downloadables', 'sound/%s' % bell_sound)
def load():
	commands()
	gamethread.delayed(20, authorites)
	config()
	get_admins()
	downloads()
	es.addons.registerClientCommandFilter(team_filter)
	ma.get_clients()
	gamethread.delayed(0.1, menus)
	gamethread.delayed(0.1, rmenu)
	es.msg("#multi", "#green[CW] #defaultClan War Plugin has been loaded.")
def menus():
	global menu, all_menu, score_menu, admin_menu, admin_overtime
	menu = popuplib.easymenu("menu", "_popup_choice", match_menu)
	menu.settitle("%s"%cw_translation("menu_tittle", None, lang=str(es.ServerVar("cw_language"))))
	menu.addoption("1", "%s (%s)"%(cw_translation("rounds", None, lang=str(es.ServerVar("cw_language"))), rounds))
	menu.addoption("2", "%s (%s)"%(cw_translation("knives", None, lang=str(es.ServerVar("cw_language"))), knives))
	menu.addoption("3", "%s: (%s)"%(cw_translation("overtime", None, lang=str(es.ServerVar("cw_language"))), overtime))
	menu.addoption("4", "%s (%s)"%(cw_translation("demo_record", None, lang=str(es.ServerVar("cw_language"))), record))
	menu.addoption("5", "%s (%s)"%(cw_translation("gameplay", None, lang=str(es.ServerVar("cw_language"))), gameplayX))
	menu.addoption("6", "%s"%(cw_translation("start", None, lang=str(es.ServerVar("cw_language")))))

	all_menu = popuplib.create('all_menu')
	all_menu.addline("%s"%cw_translation("menu_tittle", None, lang=str(es.ServerVar("cw_language"))))
	all_menu.addline("--------------------------")
	all_menu.addline("1. %s (%s)"%(cw_translation("rounds", None, lang=str(es.ServerVar("cw_language"))), rounds))
	all_menu.addline("2. %s (%s)"%(cw_translation("knives", None, lang=str(es.ServerVar("cw_language"))), knives))
	all_menu.addline("3. %s: (%s)"%(cw_translation("overtime", None, lang=str(es.ServerVar("cw_language"))), overtime))
	all_menu.addline("4. %s (%s)"%(cw_translation("demo_record", None, lang=str(es.ServerVar("cw_language"))), record))
	all_menu.addline("5. %s (%s)"%(cw_translation("gameplay", None, lang=str(es.ServerVar("cw_language"))), gameplayX))
	all_menu.addline("--------------------------")
	all_menu.addline("0. %s"%(cw_translation("exit", None, lang=str(es.ServerVar("cw_language")))))

	score_menu = popuplib.create('score_menu')
	score_menu.addline("%s"%cw_translation("score_tittle", None, lang=str(es.ServerVar("cw_language"))))	#1
	score_menu.addline("--------------------------")				#2
	score_menu.addline(" ")											#3
	score_menu.addline("%s"%(cw_translation("counter-terrorists", None, lang=str(es.ServerVar("cw_language"))))) #4
	if teamA[1] == "CT":											#5
		score_menu.addline("%s: %s"%(teamA[0], teamA[6]))
	if teamB[1] == "CT":
		score_menu.addline("%s: %s"%(teamB[0], teamB[6]))
	score_menu.addline(" ")											#6
	score_menu.addline("%s"%(cw_translation("terrorists", None, lang=str(es.ServerVar("cw_language")))))			#7
	if teamA[1] == "T":												#8
		score_menu.addline("%s: %s"%(teamA[0], teamA[6]))
	if teamB[1] == "T":
		score_menu.addline("%s: %s"%(teamB[0], teamB[6]))
	score_menu.addline(" ")											#9
	score_menu.addline("%s: None"%(cw_translation("section", None, lang=str(es.ServerVar("cw_language")))))	#10
	score_menu.addline("%s %s"%(cw_translation("played", None, lang=str(es.ServerVar("cw_language"))), played_rounds))	#11
	score_menu.addline("%s %s"%(cw_translation("needed", None, lang=str(es.ServerVar("cw_language"))), rounds_to_win))	#12
	score_menu.addline("%s %s"%(cw_translation("per_section", None, lang=str(es.ServerVar("cw_language"))), rounds))	#13
	score_menu.addline(" ")														#14
	score_menu.addline("--------------------------")							#15
	score_menu.addline("0. %s"%(cw_translation("exit", None, lang=str(es.ServerVar("cw_language")))))												#16

	admin_overtime = popuplib.easymenu("admin_overtime", "_popup_choice", overtime_menu)
	admin_overtime.settitle("%s"%cw_translation("start_overtime", None, lang=str(es.ServerVar("cw_language"))))
	admin_overtime.addoption("3", "%s 3"%(cw_translation("rounds", None, lang=str(es.ServerVar("cw_language")))))
	admin_overtime.addoption("5", "%s 5"%(cw_translation("rounds", None, lang=str(es.ServerVar("cw_language")))))
	admin_overtime.addoption("7", "%s 7"%(cw_translation("rounds", None, lang=str(es.ServerVar("cw_language")))))

	admin_menu = popuplib.easymenu("admin_menu", "_popup_choice", admin_menu)
	admin_menu.settitle("%s"%cw_translation("admin_tittle", None, lang=str(es.ServerVar("cw_language"))))
	if started == 0:
		admin_menu.addoption("plugin_opts", "%s"%(cw_translation("adm_start", None, lang=str(es.ServerVar("cw_language")))))
	if started == 1:
		admin_menu.addoption("plugin_opts", "%s"%(cw_translation("adm_stop", None, lang=str(es.ServerVar("cw_language")))))
	if int(es.ServerVar("cw_ready_system")) == 0:
		admin_menu.addoption("ready_set", "%s"%(cw_translation("ready_on", None, lang=str(es.ServerVar("cw_language")))))
	if int(es.ServerVar("cw_ready_system")) == 1:
		admin_menu.addoption("ready_set", "%s"%(cw_translation("ready_on", None, lang=str(es.ServerVar("cw_language")))))
	admin_menu.addoption("next", "%s"%(cw_translation("start_next", None, lang=str(es.ServerVar("cw_language")))))
	admin_menu.addoption("start_2", "%s"%(cw_translation("start_2", None, lang=str(es.ServerVar("cw_language")))))
	admin_menu.addoption("start_overtime", cw_translation("start_overtime", None, lang=str(es.ServerVar("cw_language"))))
def commands():
	es.regcmd('cw_stop', 'cw_plugin/stop_cmd')
	if es.exists('clientcommand', 'cw_admin'):
		es.unregclientcmd('cw_admin')
	es.regclientcmd('cw_admin', 'cw_plugin/admin_send')
	if es.exists('saycommand', 'cw_admin'):
		es.unregsaycmd("cw_admin")
	es.regsaycmd('cw_admin', 'cw_plugin/admin_send')
	if es.exists('saycommand', 'tag'):
		es.unregsaycmd("tag")
	es.regsaycmd("tag", "cw_plugin/tag", "This reg team")
	if es.exists('saycommand', 'ready'):
		es.unregsaycmd("ready")
	es.regsaycmd("ready", "cw_plugin/comm_ready", "ready")
	if es.exists('saycommand', '.r'):
		es.unregsaycmd(".r")
	es.regsaycmd(".r", "cw_plugin/comm_ready", "ready")
	if es.exists('saycommand', '/ready'):
		es.unregsaycmd("/ready")
	es.regsaycmd("/ready", "cw_plugin/comm_ready", "ready")
	if es.exists('saycommand', '/r'):
		es.unregsaycmd("/r")
	es.regsaycmd("/r", "cw_plugin/comm_ready", "ready")
	if es.exists('saycommand', '/info'):
		es.unregsaycmd("/info")
	es.regsaycmd("/info", "cw_plugin/comm_info", "info")
	if es.exists('saycommand', 'info'):
		es.unregsaycmd("info")
	es.regsaycmd("info", "cw_plugin/comm_info", "info")
	if es.exists('saycommand', '.info'):
		es.unregsaycmd(".info")
	es.regsaycmd(".info", "cw_plugin/comm_info", "info")
	if es.exists('saycommand', '.score'):
		es.unregsaycmd(".score")
	es.regsaycmd(".score", "cw_plugin/comm_score", "score")
	if es.exists('saycommand', 'score'):
		es.unregsaycmd("score")
	es.regsaycmd("score", "cw_plugin/comm_score", "score")
	if es.exists('saycommand', '/score'):
		es.unregsaycmd("/score")
	es.regsaycmd("/score", "cw_plugin/comm_score", "score")
	if es.exists('saycommand', 'unready'):
		es.unregsaycmd("unready")
	es.regsaycmd("unready", "cw_plugin/comm_unready", "unready")
	if es.exists('saycommand', '/unready'):
		es.unregsaycmd("/unready")
	es.regsaycmd("/unready", "cw_plugin/comm_unready", "unready")
	if es.exists('saycommand', '.un'):
		es.unregsaycmd(".un")
	es.regsaycmd(".un", "cw_plugin/comm_unready", "unready")
	if es.exists('saycommand', '/un'):
		es.unregsaycmd("/un")
	es.regsaycmd("/un", "cw_plugin/comm_unready", "unready")
def stop_cmd():
	if started == 1:
		stop_match()
def admin_send():
	if premission(es.getplayersteamid(es.getcmduserid())) == 1:
		if int(es.ServerVar("cw_ready_system")) == 0:
			admin_menu.setoption("ready_set", "%s"%(cw_translation("ready_on", None, lang=str(es.ServerVar("cw_language")))))
		if int(es.ServerVar("cw_ready_system")) == 1:
			admin_menu.setoption("ready_set", "%s"%(cw_translation("ready_on", None, lang=str(es.ServerVar("cw_language")))))
		admin_menu.send(es.getcmduserid())
	else:
		es.tell(es.getcmduserid(), "#multi", "#green[CW] #default %s"%(cw_translation("no_premissions", None, lang=str(es.ServerVar("cw_language")))))
def admin_menu(userid, choice, popupname):
	global resetcounter, started, overtime, rounds, played_rounds, rounds_to_win
	es.cexec(userid, "playgamesound %s"%select)
	if choice == "plugin_opts":
		if started == 0:
			es.sexec(userid, "say cwstart")
		elif started == 1:
			es.sexec(userid, "say cwstop")
	if choice == "ready_set":
		if int(es.ServerVar("cw_ready_system")) == 0:
			es.server.queuecmd("cw_ready_system 1")
			es.msg('#multi', '#green[CW] %s'%cw_translation("ready_system_on", None, lang=str(es.ServerVar("cw_language"))))
		if int(es.ServerVar("cw_ready_system")) == 1:
			es.server.queuecmd("cw_ready_system 0")
			while len(readylist) > 0:
				readylist.remove(readylist[0])
			es.msg('#multi', '#green[CW] %s'%cw_translation("ready_system_off", None, lang=str(es.ServerVar("cw_language"))))
	if choice == "next":
		if resetcounter in [1,6,7,8,9]:
			if resetcounter == 1:
				resetcounter = 2
			elif resetcounter == 6:
				resetcounter = 3
			elif resetcounter == 7:
				resetcounter = 4
			elif resetcounter == 8:
				resetcounter = 5
			elif resetcounter == 9:
				resetcounter = 4
			live()
		else:
			es.tell(userid, "#multi","#green[CW] %s"%cw_translation("must_be_started", None, lang=str(es.ServerVar("cw_language"))))
	if choice == "start_2":
		if (teamA[2]+teamB[2]) < set_rounds or set_rounds == 0:
			es.tell(userid, "#multi", "#green[CW] #default%s"%cw_translation("scores_are_reset", None, lang=str(es.ServerVar("cw_language"))))
		else:
			if started == 0:
				unload_scripts()
			teamA[3] = 0
			teamB[3] = 0
			if resetcounter in [5,9]:
				swap()
			resetcounter = 3
			rounds = set_rounds
			live()
			score_menu_refresh()
			started = 1
	if choice == "start_overtime":
		admin_overtime.send(userid)

def overtime_menu(userid, choice, popupname):
	global overtime
	es.cexec(userid, "playgamesound %s"%select)
	if choice == "3":
		overtime = 3
		overtime_fast()
	if choice == "5":
		overtime = 5
		overtime_fast()
	if choice == "7":
		overtime = 7
		overtime_fast()
def overtime_fast():
	global resetcounter, started, rounds, played_rounds, rounds_to_win, servername, knives
	if started == 0:
		unload_scripts()
	servername = str(es.ServerVar('hostname'))
	teamA[4] = teamA[5] = teamB[4] = teamB[5] = teamB[6] = teamA[6] = 0
	teamA[1] = "CT"
	teamB[1] = "T"
	teamA[0] = "Team A"
	teamB[0] = "Team B"
	resetcounter = 4
	if Team_Talk == 1:
		reg_team_talk()
	knives = "OFF"
	played_rounds = 0
	rounds = overtime
	rounds_to_win = rounds + 1
	es.server.queuecmd("mp_roundtime %s"%int(es.ServerVar("cw_overtime_round_time")))
	es.server.queuecmd("mp_startmoney %s"%int(es.ServerVar("cw_overtime_money")))
	es.msg("#multi", "#green[CW] #default%s"%cw_translation("overtime_start", None, lang=str(es.ServerVar("cw_language"))))
	es.msg("#multi", "#green[CW] #default%s"%cw_translation("ready", None, lang=str(es.ServerVar("cw_language"))))
	gamethread.delayed(3, resetcounter_set, 4)
	score_menu_refresh()
	live()
def resetcounter_set(int):
	global resetcounter, started, freezed
	resetcounter = int
	started = 1
	if freezed == 1:
		freezed = 0
	admin_menu.setoption("plugin_opts", "%s"%(cw_translation("adm_stop", None, lang=str(es.ServerVar("cw_language")))))

def authorites():
	if started == 0:
		if es.ServerVar("cw_language") == "ru":
			es.msg("#multi", "#defaultНа сервере установлен #green[CW] Plugin #default, автор которого: #greenPunisher(R)\n#defaultподробности: #greenwww.universal-games.ru")
		else:
			es.msg("#multi", "#defaultOn this server installed #green[CW] Plugin #defaultmade by #greenPunisher(R)\n#defaultvisit: #greenwww.universal-games.ru")
	gamethread.delayedname(180, "authorites", authorites)

def unload_scripts():
	es.server.queuecmd("es_xmexec ../cfg/cw_plugin/cw_on.cfg")
def loading_scripts():
	es.server.queuecmd("es_xmexec ../cfg/cw_plugin/cw_off.cfg")
def unload():
	while len(adminList) > 0:
		adminList.remove(adminList[0])
	es.msg("#multi", "#green[CW] #defaultClan War Plugin has been unloaded.")
	gamethread.cancelDelayed("authorites")
	if popuplib.exists('all_menu'):
		all_menu.delete()
	if popuplib.exists('admin_menu'):
		admin_menu.delete()
	if popuplib.exists('menu'):
		menu.delete()
	if popuplib.exists('readymenu'):
		readymenu.delete()
	if popuplib.exists('score_menu'):
		score_menu.delete()
	if popuplib.exists('admin_overtime'):
		admin_overtime.delete()
	if started == 1:
		stop_match()
	if es.exists('saycommand', 'tag'):
		es.unregsaycmd("tag")
	if es.exists('clientcommand', 'cw_admin'):
		es.unregclientcmd('cw_admin')
	if es.exists('saycommand', 'cw_admin'):
		es.unregsaycmd('cw_admin')
	if es.exists('saycommand', 'ready'):
		es.unregsaycmd("ready")
	if es.exists('saycommand', '.r'):
		es.unregsaycmd(".r")
	if es.exists('saycommand', '/ready'):
		es.unregsaycmd("/ready")
	if es.exists('saycommand', '/r'):
		es.unregsaycmd("/r")
	if es.exists('saycommand', '/info'):
		es.unregsaycmd("/info")
	if es.exists('saycommand', 'info'):
		es.unregsaycmd("info")
	if es.exists('saycommand', '.info'):
		es.unregsaycmd(".info")
	if es.exists('saycommand', '.score'):
		es.unregsaycmd(".score")
	if es.exists('saycommand', 'score'):
		es.unregsaycmd("score")
	es.regsaycmd("score", "cw_plugin/comm_score", "score")
	if es.exists('saycommand', '/score'):
		es.unregsaycmd("/score")
	if es.exists('saycommand', 'unready'):
		es.unregsaycmd("unready")
	if es.exists('saycommand', '/unready'):
		es.unregsaycmd("/unready")
	if es.exists('saycommand', '.un'):
		es.unregsaycmd(".un")
	if es.exists('saycommand', '/un'):
		es.unregsaycmd("/un")
	es.addons.unregisterClientCommandFilter(team_filter)
def comm_score():
	if started == 1:
		score_menu_refresh()
		score_menu.send(es.getcmduserid())
	else:
		es.tell(es.getcmduserid(), "#multi", "green[CW] #default%s"%cw_translation("scores_not_available", None, lang=str(es.ServerVar("cw_language"))))
def comm_ready():
	global resetcounter, readyt, readyct
	if int(es.ServerVar("cw_ready_system")) == 1:
		if resetcounter in [0, 1, 6, 7, 8, 9]:
			if int(es.ServerVar("cw_warmod_comtable")) == 1:
				if es.getplayerteam(es.getcmduserid()) in [2,3]:
					if str(es.getcmduserid()) in readylist:
						es.tell(es.getcmduserid(), '#multi', '#green[CW] %s'%cw_translation("already_ready", None, lang=str(es.ServerVar("cw_language"))))
					else:
						es.tell(es.getcmduserid(), '#multi', '#green[CW] %s'%cw_translation("you_ready", None, lang=str(es.ServerVar("cw_language"))))
						readylist.append(str(es.getcmduserid()))
						rmenu()
						if len(readylist) == gameplay*2:
							mix = 1
							for userid in readylist:
								if not ((es.getplayerteam(userid) != 2) or (es.getplayerteam(userid) != 3)):
									readylist.remove(userid)
									mix = 0
							if mix == 1:
								while len(readylist) > 0:
									readylist.remove(readylist[0])
								if resetcounter == 0:
									config()
									match_go()
								else:
									if resetcounter == 1:
										gamethread.delayed(3, resetcounter_set, 2)
									elif resetcounter == 6:
										gamethread.delayed(3, resetcounter_set, 3)
									elif resetcounter == 7:
										gamethread.delayed(3, resetcounter_set, 4)
									elif resetcounter == 8:
										gamethread.delayed(3, resetcounter_set, 5)
									elif resetcounter == 9:
										gamethread.delayed(3, resetcounter_set, 4)
									live()
				else:
					es.tell(es.getcmduserid(), '#multi', '#green[CW] %s'%cw_translation("must_be_in_team", None, lang=str(es.ServerVar("cw_language"))))
			else:
				if started == 1:
					if es.getplayerteam(es.getcmduserid()) == 2:
						if readyt == 0:
							readyt = 1
							es.msg("#multi", "#green[CW] #default%s"%cw_translation("T_ready", None, lang=str(es.ServerVar("cw_language"))))
							if readyct == 1:
								es.msg ("#multi", "#green[CW] #default%s"%cw_translation("booth_ready", None, lang=str(es.ServerVar("cw_language"))))
								es.centermsg("%s"%cw_translation("booth_ready_center", None, lang=str(es.ServerVar("cw_language"))))
								if resetcounter == 1:
									gamethread.delayed(3, resetcounter_set, 2)
								elif resetcounter == 6:
									gamethread.delayed(3, resetcounter_set, 3)
								elif resetcounter == 7:
									gamethread.delayed(3, resetcounter_set, 4)
								elif resetcounter == 8:
									gamethread.delayed(3, resetcounter_set, 5)
								elif resetcounter == 9:
									gamethread.delayed(3, resetcounter_set, 4)
								live()
								readyct = 0
								readyt = 0
					elif es.getplayerteam(es.getcmduserid()) == 3:
						if readyct == 0:
							readyct = 1
							es.msg("#multi", "#green[CW] #default%s"%cw_translation("CT_ready", None, lang=str(es.ServerVar("cw_language"))))
							if readyt == 1:
								es.msg ("#multi", "#green[CW] #default%s"%cw_translation("booth_ready", None, lang=str(es.ServerVar("cw_language"))))
								es.centermsg("%s"%cw_translation("booth_ready_center", None, lang=str(es.ServerVar("cw_language"))))
								if resetcounter == 1:
									resetcounter = 2
								elif resetcounter == 6:
									resetcounter = 3
								elif resetcounter == 7:
									resetcounter = 4
								elif resetcounter == 8:
									resetcounter = 5
								elif resetcounter == 9:
									resetcounter = 4
								live()
								readyct = 0
								readyt = 0
	else:
		es.tell(es.getcmduserid(), '#multi', '#green[CW] %s'%cw_translation("ready_system_off", None, lang=str(es.ServerVar("cw_language"))))
def comm_unready():
	if resetcounter in [0, 1, 6, 7, 8, 9]:
		if int(es.ServerVar("cw_warmod_comtable")) == 1:
			if str(es.getcmduserid()) in readylist:
				readylist.remove(str(es.getcmduserid()))
				es.tell(es.getcmduserid(), '#multi', '#green[CW] %s'%cw_translation("were_removed_ready", None, lang=str(es.ServerVar("cw_language"))))
				rmenu()
			else:
				es.tell(es.getcmduserid(), '#multi', '#green[CW] %s'%cw_translation("were_not_ready", None, lang=str(es.ServerVar("cw_language"))))
def comm_info():
	if int(es.ServerVar("cw_warmod_comtable")) == 1:
		if resetcounter in [0, 1, 6, 7, 8, 9]:
			readymenu.send(es.getcmduserid())
		else:
			es.tell(es.getcmduserid(), '#multi', '#green[CW] %s'%cw_translation("no_ready", None, lang=str(es.ServerVar("cw_language"))))

def premission(steamid):
	if int(es.ServerVar("cw_only_admins")) == 0:
		return 1
	elif (int(es.ServerVar("cw_only_admins")) == 1):
		if steamid in adminList:
			return 1
		elif int(es.ServerVar("cw_mani_admins")) == 1:
			if ma.isAdmin(steamid) == 1:
				if str(es.ServerVar("cw_mani_flag")) == "":
					return 1
				elif ma.hasFlag(steamid, es.ServerVar("cw_mani_flag"))>0:
					return 1
				elif ma.hasGroup(steamid, es.ServerVar("cw_mani_flag"))>0:
					return 1
	return 0
def check_admin(steamid):
	if steamid in adminList:
		return 1
	if int(es.ServerVar("cw_mani_admins")) == 1:
		if ma.isAdmin(steamid) == 1:
			if str(es.ServerVar("cw_mani_flag")) == "":
				return 1
			elif ma.hasFlag(steamid, es.ServerVar("cw_mani_flag"))>0:
				return 1
			elif ma.hasGroup(steamid, es.ServerVar("cw_mani_flag"))>0:
				return 1
	return 0
def es_player_chat(ev):
	if started == 1:
		if int(es.ServerVar("cw_team_chat")) == 1:
			if ev['teamonly'] == '1':
				if es.getplayerprop(ev['userid'], "CCSPlayer.baseclass.pl.deadflag") == 1:
					if es.getplayerteam(ev['userid']) == 2:
						usermsg.saytext2(aliveT, playerlib.getPlayer(ev['userid']).index, '\x01%s \x03%s\x01: %s'%(cw_translation("dead", lang=str(es.ServerVar("cw_language"))), es.getplayername(ev['userid']), ev['text']))
					elif es.getplayerteam(ev['userid']) == 3:
						usermsg.saytext2(aliveCT, playerlib.getPlayer(ev['userid']).index, '\x01%s \x03%s\x01: %s'%(cw_translation("dead", lang=str(es.ServerVar("cw_language"))), es.getplayername(ev['userid']), ev['text']))
def player_say(ev):
	global readyt, readyct, knive_winner, reserved
	if ev['text'] == "cwstart":
		if started == 0:
			isqueued = 0
			if popuplib.isqueued('menu', ev['userid']):
				menu.unsend(ev['userid'])
			for userid in es.getUseridList():
				if popuplib.isqueued('menu', userid):
					isqueued = 1
			if isqueued == 0:
				if premission(ev['es_steamid']) == 1:
					config()
					reset_menu()
					reserved = ev['userid']
					for userid in es.getUseridList():
						if str(userid) != ev['userid']:
							PlayerList.append(userid)
					all_menu.send(PlayerList)
					menu.send(ev['userid'])
					freeze()
				else:
					es.tell(ev['userid'], "#multi", "#green[CW] #default %s"%(cw_translation("no_premissions", None, lang=str(es.ServerVar("cw_language")))))
			if isqueued == 1:
				es.tell(ev['userid'], "#multi", "#green[CW] #default %s"%(cw_translation("menu_exists", None, lang=str(es.ServerVar("cw_language")))))
	elif ev['text'] == "cwstop":
		if started == 1:
			if (premission(ev['es_steamid']) == 1) or (ev['es_steamid'] == reserved):
				es.msg("#multi", "#green[CW] #default%s %s"%(cw_translation("user_stop", None, lang=str(es.ServerVar("cw_language"))), ev['es_username']))
				stop_match()
			else:
				es.tell(ev['userid'], "#multi", "#green[CW] #default %s"%(cw_translation("no_premissions", None, lang=str(es.ServerVar("cw_language")))))

	elif ev['text'] == "stay":
		if resetcounter == 1:
			if knive_winner != 0:
				if ev['es_userteam'] == '2':
					if knive_winner == 2:
						knive_winner = 0
						es.msg("#multi", "#green[CW] #default%s"%cw_translation("T_ready", None, lang=str(es.ServerVar("cw_language"))))
						readyt = 1
				elif ev['es_userteam'] == '3':
					if knive_winner == 3:
						knive_winner = 0
						es.msg("#multi", "#green[CW] #default%s"%cw_translation("CT_ready", None, lang=str(es.ServerVar("cw_language"))))
						readyct = 1

	elif ev['text'] == "T":
		if resetcounter == 1:
			if knive_winner != 0:
				if ev['es_userteam'] == '3':
					if knive_winner == 3:
						es.msg("#multi", "#green[CW] #default%s"%cw_translation("swap", None, lang=str(es.ServerVar("cw_language"))))
						swap()
						knive_winner = 0
						if not int(es.ServerVar("cw_warmod_comtable")) == 1:
							es.msg("#multi", "#green[CW] #default%s"%cw_translation("T_ready", None, lang=str(es.ServerVar("cw_language"))))
							readyt = 1
				elif ev['es_userteam'] == '2':
					if knive_winner == 2:
						knive_winner = 0
						if not int(es.ServerVar("cw_warmod_comtable")) == 1:
							es.msg("#multi", "#green[CW] #default%s"%cw_translation("T_ready", None, lang=str(es.ServerVar("cw_language"))))
							readyt = 1

	elif ev['text'] == "CT":
		if resetcounter == 1:
			if knive_winner != 0:
				if ev['es_userteam'] == '2':
					if knive_winner == 2:
						es.msg("#multi", "#green[CW] #default%s"%cw_translation("swap", None, lang=str(es.ServerVar("cw_language"))))
						swap()
						knive_winner = 0
						if not int(es.ServerVar("cw_warmod_comtable")) == 1:
							es.msg("#multi", "#green[CW] #default%s"%cw_translation("CT_ready", None, lang=str(es.ServerVar("cw_language"))))
							readyct = 1
				elif ev['es_userteam'] == '3':
					if knive_winner == 3:
						knive_winner = 0
						if not int(es.ServerVar("cw_warmod_comtable")) == 1:
							es.msg("#multi", "#green[CW] #default%s"%cw_translation("CT_ready", None, lang=str(es.ServerVar("cw_language"))))
							readyct = 1
def rmenu():
	global readymenu
	readymenu = popuplib.easymenu('readymenu','_popup_choice', r_menu)
	readymenu.settitle(cw_translation("r_tittle", None, lang=str(es.ServerVar("cw_language"))))
	for userid in es.getUseridList():
		if (es.getplayerteam(userid) == 2) or (es.getplayerteam(userid) == 3):
			if not str(userid) in readylist:
				readymenu.addoption(userid, es.getplayername(userid))
	for userid in es.getUseridList():
		if popuplib.isqueued('readymenu', userid):
			readymenu.unsend(userid)
			readymenu.send(userid)
def r_menu(userid, choice, popupname):
	readymenu.unsend(userid)
	readymenu.send(userid)
	es.cexec(userid, "playgamesound %s"%select)
def match_menu(userid, choice, popupname):
	global rounds, knives, overtime, record, rounds_to_win, freezed, gameplay, gameplayX, reserved
	es.cexec(userid, "playgamesound %s"%select)
	if choice == "1":
		if rounds == 3:
			rounds = 5
		elif rounds == 5:
			rounds = 7
		elif rounds == 7:
			rounds = 9
		elif rounds == 9:
			rounds = 12
		elif rounds == 12:
			rounds = 15
		elif rounds == 15:
			rounds = 3
		menu.setoption ("1", "%s (%s)"%(cw_translation("rounds", None, lang=str(es.ServerVar("cw_language"))), rounds))
		all_menu.modline(3, "1. %s (%s)"%(cw_translation("rounds", None, lang=str(es.ServerVar("cw_language"))), rounds))
	if choice == "2":
		if knives == "ON":
			knives = "OFF"
		elif knives == "OFF":
			knives = "ON"
		menu.setoption ("2", "%s (%s)"%(cw_translation("knives", None, lang=str(es.ServerVar("cw_language"))), knives))
		all_menu.modline(4, "2. %s (%s)"%(cw_translation("knives", None, lang=str(es.ServerVar("cw_language"))), knives))
	if choice == "3":
		if overtime == "OFF":
			overtime = 1
		elif overtime == 1:
			overtime = 3
		elif overtime == 3:
			overtime = 5
		elif overtime == 5:
			overtime = "OFF"
		menu.setoption ("3", "%s: (%s)"%(cw_translation("overtime", None, lang=str(es.ServerVar("cw_language"))), overtime))
		all_menu.modline(5, "3. %s: (%s)"%(cw_translation("overtime", None, lang=str(es.ServerVar("cw_language"))), overtime))
	if choice == "4":
		if record == "ON":
			record = "OFF"
		elif record == "OFF":
			record = "ON"
		menu.setoption ("4", "%s (%s)"%(cw_translation("demo_record", None, lang=str(es.ServerVar("cw_language"))), record))
		all_menu.modline(6, "4. %s (%s)"%(cw_translation("demo_record", None, lang=str(es.ServerVar("cw_language"))), record))
		
	if choice == "5":
		if gameplay == 1:
			gameplay = 2
		elif gameplay == 2:
			gameplay = 3
		elif gameplay == 3:
			gameplay = 4
		elif gameplay == 4:
			gameplay = 5
		elif gameplay == 5:
			gameplay = 1
		gameplayX = str(str(gameplay) + "x" + str(gameplay))
		menu.setoption ("5", "%s (%s)"%(cw_translation("gameplay", None, lang=str(es.ServerVar("cw_language"))), gameplayX))
		all_menu.modline(7, "5. %s (%s)"%(cw_translation("gameplay", None, lang=str(es.ServerVar("cw_language"))), gameplayX))

	if choice in ["1", "2", "3", "4", "5"]:
		menu.unsend(userid)
		menu.send(userid)
		all_menu.unsend(PlayerList)
		all_menu.send(PlayerList)

	if choice == "6":
		reserved = 0
		menu.unsend(userid)
		match_go()
		all_menu.unsend(PlayerList)
		freezed = 0

def reset_menu():
	global menu
	menu.setoption("1", "%s (%s)"%(cw_translation("rounds", None, lang=str(es.ServerVar("cw_language"))), rounds))
	menu.setoption("2", "%s (%s)"%(cw_translation("knives", None, lang=str(es.ServerVar("cw_language"))), knives))
	menu.setoption("3", "%s: (%s)"%(cw_translation("overtime", None, lang=str(es.ServerVar("cw_language"))), overtime))
	menu.setoption("4", "%s (%s)"%(cw_translation("demo_record", None, lang=str(es.ServerVar("cw_language"))), record))
	menu.setoption("5", "%s (%s)"%(cw_translation("gameplay", None, lang=str(es.ServerVar("cw_language"))), gameplayX))
	menu.setoption("6", "%s"%(cw_translation("start", None, lang=str(es.ServerVar("cw_language")))))
	
	global all_menu
	all_menu.modline(3, "1. %s (%s)"%(cw_translation("rounds", None, lang=str(es.ServerVar("cw_language"))), rounds))
	all_menu.modline(4, "2. %s (%s)"%(cw_translation("knives", None, lang=str(es.ServerVar("cw_language"))), knives))
	all_menu.modline(5, "3. %s: (%s)"%(cw_translation("overtime", None, lang=str(es.ServerVar("cw_language"))), overtime))
	all_menu.modline(6, "4. %s (%s)"%(cw_translation("demo_record", None, lang=str(es.ServerVar("cw_language"))), record))
	all_menu.modline(7, "5. %s (%s)"%(cw_translation("gameplay", None, lang=str(es.ServerVar("cw_language"))), gameplayX))

def tag():
	userid = es.getcmduserid()
	if resetcounter > 1:
		if es.getplayerteam(userid) == 2:
			if teamA[1] == "T":
				teamA[0] = es.getargs()
				es.msg("#multi", "#green[CW] #default%s %s"%(cw_translation("team_t_name", None, lang=str(es.ServerVar("cw_language"))), teamA[0]))
			
			elif teamB[1] == "T":
				teamB[0] = es.getargs()
				es.msg("#multi", "#green[CW] #default%s %s"%(cw_translation("team_t_name", None, lang=str(es.ServerVar("cw_language"))), teamB[0]))
			
		elif es.getplayerteam(userid) == 3:	
			if teamA[1] == "CT":
				teamA[0] = es.getargs()
				es.msg("#multi", "#green[CW] #default%s %s"%(cw_translation("team_ct_name", None, lang=str(es.ServerVar("cw_language"))), teamA[0]))
			
			elif teamB[1] == "CT":
				teamB[0] = es.getargs()
				es.msg("#multi", "#green[CW] #default%s %s"%(cw_translation("team_ct_name", None, lang=str(es.ServerVar("cw_language"))), teamB[0]))
		score_menu_refresh()
	else:
		es.msg("#multi", "#green[CW] #default%s"%cw_translation("tag_off", None, lang=str(es.ServerVar("cw_language"))))
def player_disconnect(ev):
	global freezed, reserved
	if not es.isbot(ev['userid']):
		if ev['es_steamid'] != 'BOT':
			if started == 0:
				if not es.isbot(ev['userid']):
					if reserved == ev['userid']:
						freezed = 0
						if int(es.ServerVar("cw_only_admins")) == 1:
							reserved = 0
						es.server.queuecmd("mp_restartgame 2")
			if started == 1:
				if len(playerlib.getPlayerList('#human')) <= 1:
					stop_match()
				if ev['userid'] in dead_t_List:
					dead_t_List.remove(ev['userid'])
				if ev['userid'] in dead_ct_List:
					dead_ct_List.remove(ev['userid'])
			if ev['userid'] in readylist:
				readylist.remove(ev['userid'])
def stop_match():
	global started, set_rounds, played_rounds, resetcounter, rounds_to_win, knive_winner
	es.msg ("#multi", "#green[CW] #default%s"%cw_translation("cw_stoped", None, lang=str(es.ServerVar("cw_language"))))
	admin_menu.setoption("plugin_opts", "%s"%(cw_translation("adm_start", None, lang=str(es.ServerVar("cw_language")))))
	for userid in es.getUseridList():
		if popuplib.isqueued('admin_menu', userid):
			admin_menu.unsend(userid)
			admin_menu.send(userid)
	loading_scripts()
	if started == 1:
		if es.getInt('tv_enable') == 1:
			if record == "ON":
				if demo_name_g:
					es.server.queuecmd("tv_stoprecord")
					es.delayed("5", "es_xmsg #multi %s #green%s"%(cw_translation("demo_stoped", None, lang=str(es.ServerVar("cw_language"))), demo_name_g))
	es.server.queuecmd("bot_all_weapons")
	es.server.queuecmd("hostname %s" % str(servername))
	es.server.queuecmd("mp_startmoney 800")
	es.server.queuecmd("mp_restartgame 3")
	es.server.queuecmd("mp_roundtime 1.75")
	if str(es.ServerVar("cw_language")) == "ru":
		es.delayed("5", "es_xmsg #multi #defaultСпасибо, что использовали #green[CW] Plugin")
	if str(es.ServerVar("cw_language")) != "ru":
		es.delayed("5", "es_xmsg #multi #defaultThank you for using #green[CW] Plugin")
	if Team_Talk == 1:
		unreg_team_talk()
	started = 0
	set_rounds = 0
	played_rounds = 0
	resetcounter = 0
	rounds_to_win = 0
	knive_winner = 0
def round_end(ev):
	global resetcounter, rounds, knives, started, set_rounds, played_rounds, score_menu, rounds_to_win, knive_winner
	if started == 1:
		if knives == "ON":
			if ev["winner"] in ["2","3"]:
				if ev["winner"] == "2":
					resetcounter = 1
					knive_winner = 2
					es.msg("#multi", "#green[CW] #default%s"%cw_translation("t_knives_won", None, lang=str(es.ServerVar("cw_language"))))
				elif ev["winner"] == "3":
					resetcounter = 1
					knive_winner = 3
					es.msg("#multi", "#green[CW] #default%s"%cw_translation("ct_knives_won", None, lang=str(es.ServerVar("cw_language"))))
				knives = "OFF"
				es.msg("#multi", "#green[CW] #default%s"%cw_translation("ready", None, lang=str(es.ServerVar("cw_language"))))
				es.msg("#multi", "#green[CW] #default%s"%cw_translation("knive_winner", None, lang=str(es.ServerVar("cw_language"))))
				es.server.queuecmd("bot_all_weapons")
				es.server.queuecmd("mp_restartgame 1")
				es.server.queuecmd("mp_startmoney 800")
			else:
				es.msg ("#multi", "#green[CW] #default%s"%cw_translation("not_success", None, lang=str(es.ServerVar("cw_language"))))
				knive_round()
		elif resetcounter == 2:
			if ev["winner"] == "2":
				rounds -= 1
				played_rounds += 1
				teamA[2] += 1
				teamA[6] = (teamA[2] + teamA[3])
				score()
			elif ev["winner"] == "3":
				rounds -= 1
				played_rounds += 1
				teamB[2] += 1
				teamB[6] = (teamB[2] + teamB[3])
				score()
			if rounds == 0:
				es.msg("#multi", "#green[CW] #default%s"%cw_translation("swap", None, lang=str(es.ServerVar("cw_language"))))
				gamethread.delayed(2, swap)
				rounds = set_rounds
				readyt = 0
				readyct = 0
				resetcounter = 6
				es.msg("#multi", "#green[CW] #default%s"%cw_translation("ready", None, lang=str(es.ServerVar("cw_language"))))

		elif resetcounter == 3:
			if ev["winner"] == "2":
				rounds -= 1
				played_rounds += 1
				teamB[3] += 1
				teamB[6] = (teamB[2] + teamB[3])
				if teamB[6] == (set_rounds + 1):
					es.msg ("#multi", "#green[CW] #default%s #green%s #default%s"%(cw_translation("team", None, lang=str(es.ServerVar("cw_language"))), teamB[0], cw_translation("won", None, lang=str(es.ServerVar("cw_language")))))
					es.msg ("#multi", "#green[CW] #default%s #green%s #default(%s) - #green%s #default(%s)"%(cw_translation("total_score", None, lang=str(es.ServerVar("cw_language"))), teamB[0], teamB[6], teamA[0], teamA[6]))
					stop_match()
				else:
					score()
			elif ev["winner"] == "3":
				rounds -= 1
				played_rounds += 1
				teamA[3] += 1
				teamA[6] = (teamA[2] + teamA[3])
				if teamA[6] == (set_rounds + 1):
					es.msg ("#multi", "#green[CW] #default%s #green%s #default%s"%(cw_translation("team", None, lang=str(es.ServerVar("cw_language"))), teamA[0], cw_translation("won", None, lang=str(es.ServerVar("cw_language")))))
					es.msg ("#multi", "#green[CW] #default%s #green%s #default(%s) - #green%s #default(%s)"%(cw_translation("total_score", None, lang=str(es.ServerVar("cw_language"))),teamA[0], teamA[6], teamB[0], teamB[6]))
					stop_match()
				else:
					score()
			if teamA[6] == set_rounds:
				if teamA[6] == teamB[6]:
					if overtime == ("OFF" or 0):
						es.msg ("#multi", "#green[CW] #default%s"%(cw_translation("drawn_game", None, lang=str(es.ServerVar("cw_language")))))
						stop_match()
					else:
						teamA[6] = (teamA[5] + teamA[4])
						teamB[6] = (teamB[5] + teamB[4])
						played_rounds = 0
						rounds = overtime
						rounds_to_win = rounds + 1
						es.server.queuecmd("mp_startmoney %s"%int(es.ServerVar("cw_overtime_money")))
						es.server.queuecmd("mp_roundtime %s"%int(es.ServerVar("cw_overtime_round_time")))
						es.msg("#multi", "#green[CW] #default%s"%cw_translation("overtime_start", None, lang=str(es.ServerVar("cw_language"))))
						readyt = 0
						readyct = 0
						resetcounter = 7
						es.msg("#multi", "#green[CW] #default%s"%cw_translation("ready", None, lang=str(es.ServerVar("cw_language"))))
		elif resetcounter == 4:
			if ev["winner"] == "2":
				rounds -= 1
				played_rounds += 1
				teamB[4] += 1
				teamB[6] = (teamB[5] + teamB[4])
				score()
			elif ev["winner"] == "3":
				rounds -= 1
				played_rounds += 1
				teamA[4] += 1
				teamA[6] = (teamA[5] + teamA[4])
				score()
			if rounds == 0:
				es.msg("#multi", "#green[CW] #default%s"%cw_translation("swap", None, lang=str(es.ServerVar("cw_language"))))
				gamethread.delayed(2, swap)
				rounds = overtime
				readyt = 0
				readyct = 0
				resetcounter = 8
				es.msg("#multi", "#green[CW] #default%s"%cw_translation("ready", None, lang=str(es.ServerVar("cw_language"))))
		elif resetcounter == 5:
			if ev["winner"] == "2":
				played_rounds += 1
				rounds -= 1
				teamA[5] += 1
				teamA[6] = (teamA[5] + teamA[4])
				if teamA[6] == overtime + 1:
					es.msg ("#multi", "#green[CW] #default%s #green%s #default%s"%(cw_translation("team", None, lang=str(es.ServerVar("cw_language"))), teamA[0], cw_translation("won", None, lang=str(es.ServerVar("cw_language")))))
					es.msg ("#multi", "#green[CW] #default%s #green%s #default(%s) - #green%s #default(%s)"%(cw_translation("total_score", None, lang=str(es.ServerVar("cw_language"))), teamA[0], teamA[6], teamB[0], teamB[6]))
					stop_match()
				else:
					score()
			elif ev["winner"] == "3":
				played_rounds += 1
				rounds -= 1
				teamB[5] += 1
				teamB[6] = (teamB[5] + teamB[4])
				if teamB[6] == overtime + 1:
					es.msg ("#multi", "#green[CW] #default%s #green%s #default%s"%(cw_translation("team", None, lang=str(es.ServerVar("cw_language"))), teamB[0], cw_translation("won", None, lang=str(es.ServerVar("cw_language")))))
					es.msg ("#multi", "#green[CW] #default%s #green%s #default(%s) - #green%s #default(%s)"%(cw_translation("total_score", None, lang=str(es.ServerVar("cw_language"))), teamB[0], teamB[6], teamA[0], teamA[6]))
					stop_match()
				else:
					score()
			if teamB[6] == overtime:
				if teamB[6] == teamA[6]:
					es.msg("#multi", "#green[CW] #default%s"%cw_translation("overtime_draw", None, lang=str(es.ServerVar("cw_language"))))
					rounds = overtime
					rounds_to_win = overtime + 1
					played_rounds = 0
					es.msg("#multi", "#green[CW] #default%s"%cw_translation("swap", None, lang=str(es.ServerVar("cw_language"))))
					gamethread.delayed(2, swap)
					readyt = 0
					readyct = 0
					resetcounter = 9
					es.msg("#multi", "#green[CW] #default%s"%cw_translation("ready", None, lang=str(es.ServerVar("cw_language"))))
		score_menu_refresh()
def score():
	info = {}
	info['teamA_name'] = teamA[0]
	info['teamA_team'] = teamA[1]
	info['teamA_score'] = teamA[6]
	info['teamB_name'] = teamB[0]
	info['teamB_team'] = teamB[1]
	info['teamB_score'] = teamB[6]
	if teamA[6] > teamB[6]:
		es.msg("#multi", "#green[CW] #default%s"%cw_translation("A_winning", info, lang=str(es.ServerVar("cw_language"))))
	if teamA[6] < teamB[6]:
		es.msg("#multi", "#green[CW] #default%s"%cw_translation("B_winning", info, lang=str(es.ServerVar("cw_language"))))
	if teamA[6] == teamB[6]:
		es.msg("#multi", "#green[CW] #default%s"%cw_translation("A_B_draw", info, lang=str(es.ServerVar("cw_language"))))
	es.msg("#multi", "#green[CW] #default%s %s"%(cw_translation("remain", None, lang=str(es.ServerVar("cw_language"))), rounds))
	if resetcounter in [4,5]:
		es.server.queuecmd('hostname "%s %s %s(%s) %s %s(%s)"'%(serv_name, cw_translation("hostname_overtime", None, lang=str(es.ServerVar("cw_language"))), teamA[0], teamA[6], cw_translation("hostname_vs", None, lang=str(es.ServerVar("cw_language"))), teamB[0], teamB[6]))
	else:
		es.server.queuecmd('hostname "%s %s %s(%s) %s %s(%s)"'%(serv_name, cw_translation("hostname_live", lang=str(es.ServerVar("cw_language"))), teamA[0], teamA[6], cw_translation("hostname_vs", None, lang=str(es.ServerVar("cw_language"))), teamB[0], teamB[6]))
def score_menu_refresh():
	if teamA[1] == "CT":											#5
		score_menu.modline(5,"%s: %s"%(teamA[0], teamA[6]))
	if teamB[1] == "CT":
		score_menu.modline(5,"%s: %s"%(teamB[0], teamB[6]))
	if teamA[1] == "T":												#8
		score_menu.modline(8,"%s: %s"%(teamA[0], teamA[6]))
	if teamB[1] == "T":
		score_menu.modline(8,"%s: %s"%(teamB[0], teamB[6]))
	if resetcounter == 2:
		score_menu.modline(10, "%s: %s"%(cw_translation("section", None, lang=str(es.ServerVar("cw_language"))),cw_translation("first", None, lang=str(es.ServerVar("cw_language")))))
	if resetcounter == 3:
		score_menu.modline(10, "%s: %s"%(cw_translation("section", None, lang=str(es.ServerVar("cw_language"))),cw_translation("second", None, lang=str(es.ServerVar("cw_language")))))
	if resetcounter in [4,5]:
		score_menu.modline(10, "%s: %s"%(cw_translation("section", None, lang=str(es.ServerVar("cw_language"))),cw_translation("overtime", None, lang=str(es.ServerVar("cw_language")))))
	if not resetcounter in [2,3,4,5]:
		score_menu.modline(10, "%s"%(cw_translation("nonsection", None, lang=str(es.ServerVar("cw_language")))))
	score_menu.modline(11, "3. %s %s"%(cw_translation("played", None, lang=str(es.ServerVar("cw_language"))), played_rounds))
	score_menu.modline(12, "4. %s %s"%(cw_translation("needed", None, lang=str(es.ServerVar("cw_language"))), rounds_to_win))
	score_menu.modline(13, "5. %s %s"%(cw_translation("per_section", None, lang=str(es.ServerVar("cw_language"))), rounds))
	
	for userid in es.getUseridList():
		if popuplib.isqueued('score_menu', userid):
			score_menu.unsend(userid)
			score_menu.send(userid)
	if resetcounter > 3 and resetcounter < 6:
		es.server.queuecmd('hostname "%s %s %s(%s) %s %s(%s)"'%(serv_name, cw_translation("hostname_overtime", None, lang=str(es.ServerVar("cw_language"))), teamA[0], teamA[6], cw_translation("hostname_vs", None, lang=str(es.ServerVar("cw_language"))), teamB[0], teamB[6]))
	else:
		es.server.queuecmd('hostname "%s %s %s(%s) %s %s(%s)"'%(serv_name, cw_translation("hostname_live", lang=str(es.ServerVar("cw_language"))), teamA[0], teamA[6], cw_translation("hostname_vs", None, lang=str(es.ServerVar("cw_language"))), teamB[0], teamB[6]))
def knive_round():
	es.server.queuecmd("echo =========================")
	es.server.queuecmd("echo executing new knive round")
	es.server.queuecmd("echo =========================")

	es.delayed("1", "es_xcentermsg %s"%cw_translation("live_next_reset", None, lang=str(es.ServerVar("cw_language"))))
	es.delayed("1", "es_xmsg #multi #green[CW] #default%s"%cw_translation("knife_next_reset", None, lang=str(es.ServerVar("cw_language"))))
	es.delayed("2", "mp_restartgame 1")
	es.delayed("2", "bot_knives_only")
	
	es.delayed("5", "es_xmsg #multi #green[CW] #default%s"%cw_translation("knife", None, lang=str(es.ServerVar("cw_language"))))
	es.delayed("5", "es_xcentermsg %s"%cw_translation("live", None, lang=str(es.ServerVar("cw_language"))))

	es.delayed("6", "es_xmsg #multi #green[CW] #default%s"%cw_translation("knife", None, lang=str(es.ServerVar("cw_language"))))
	es.delayed("6", "es_xcentermsg %s"%cw_translation("live", None, lang=str(es.ServerVar("cw_language"))))

	es.delayed("7", "es_xmsg #multi #green[CW] #default%s"%cw_translation("knife", None, lang=str(es.ServerVar("cw_language"))))
	es.delayed("7", "es_xcentermsg %s"%cw_translation("knife", None, lang=str(es.ServerVar("cw_language"))))

	es.delayed("7", "es_cexec_all playgamesound %s"%bell_sound)

	es.delayed("8", "es_xmsg #multi #green[CW] #default%s"%cw_translation("knife_now", None, lang=str(es.ServerVar("cw_language"))))
	es.delayed("8", "es_xcentermsg %s"%cw_translation("live_now", None, lang=str(es.ServerVar("cw_language"))))
	es.delayed("8", "echo knive match is live!")
def live():
	es.server.queuecmd("echo =========================")
	es.server.queuecmd("echo      Match is live!      ")
	es.server.queuecmd("echo =========================")

	es.delayed("1", "es_xcentermsg %s"%cw_translation("live_next_reset", None, lang=str(es.ServerVar("cw_language"))))
	es.delayed("1", "es_xmsg #multi #green[CW] #default%s"%cw_translation("live_next_reset", None, lang=str(es.ServerVar("cw_language"))))
	es.delayed("2", "mp_restartgame 1")
	
	es.delayed("5", "es_xmsg #multi #green[CW] #default%s"%cw_translation("live", None, lang=str(es.ServerVar("cw_language"))))
	es.delayed("5", "es_xcentermsg %s"%cw_translation("live", None, lang=str(es.ServerVar("cw_language"))))

	es.delayed("6", "es_xmsg #multi #green[CW] #default%s"%cw_translation("live", None, lang=str(es.ServerVar("cw_language"))))
	es.delayed("6", "es_xcentermsg %s"%cw_translation("live", None, lang=str(es.ServerVar("cw_language"))))

	es.delayed("7", "es_xmsg #multi #green[CW] #default%s"%cw_translation("live", None, lang=str(es.ServerVar("cw_language"))))
	es.delayed("7", "es_xcentermsg %s"%cw_translation("live", None, lang=str(es.ServerVar("cw_language"))))

	es.delayed("7", "es_cexec_all playgamesound %s"%bell_sound)

	es.delayed("8", "es_xmsg #multi #green[CW] #default%s"%cw_translation("live_now", None, lang=str(es.ServerVar("cw_language"))))
	es.delayed("8", "es_xcentermsg %s"%cw_translation("live_now", None, lang=str(es.ServerVar("cw_language"))))
	es.delayed("8", "echo match is live!")
def match_go():
	global resetcounter, started, set_rounds, servername, rounds_to_win, demo_name_g
	if Team_Talk == 1:
		reg_team_talk()
	servername = str(es.ServerVar('hostname'))
	set_rounds = rounds
	rounds_to_win = rounds + 1
	unload_scripts()
	# Demo recording
	es.server.queuecmd('hostname "%s %s %s(%s) %s %s(%s)"'%(serv_name, cw_translation("hostname_live", lang=str(es.ServerVar("cw_language"))), teamA[0], teamA[6], cw_translation("hostname_vs", None, lang=str(es.ServerVar("cw_language"))), teamB[0], teamB[6]))
	if resetcounter == 0:
		if es.getInt('tv_enable') == 1:
			if record == "ON":
				es.server.queuecmd("tv_stoprecord")
				demo_dir1 = ""
				demo_dir2 = ""
				demo_dir = str(es.ServerVar("cw_demo_dir"))
				demo_name = str(es.ServerVar("cw_demo_name"))
				if str(es.ServerVar("cw_demo_dir")) != "":
					n=0
					if demo_dir.startswith('%'):
						demo_dir = " "+demo_dir
						n=1
					if demo_dir.find('%map'):
						demo_dir = demo_dir.replace('%map', str(es.ServerVar('eventscripts_currentmap')))
					if demo_dir.find('%d'):
						demo_dir = demo_dir.replace('%d', str(time.strftime("%d", localtime())))
					if demo_dir.find('%m'):
						demo_dir = demo_dir.replace('%m', str(time.strftime("%m", localtime())))
					if demo_dir.find('%y'):
						demo_dir = demo_dir.replace('%y', str(time.strftime("%y", localtime())))
					if n==1:
						demoX = ""
						while n!= len(demo_dir):
							demoX+= demo_dir[n]
							n+=1
						demo_dir = demoX
					if str(demo_dir).endswith('/'):
						for item in str(demo_dir).split('/'):
							if item != "":
								demo_dir2 += "/"+item
					if not str(demo_dir).endswith('/'):
						demo_dir2 = demo_dir
					if str(demo_dir).startswith('/'):
						demo_dir = demo_dir
					if not str(demo_dir).startswith('/'):
						for item in str(demo_dir).split('/'):
							if item != "":
								demo_dir1 += item+"/"
				if not os.path.exists(str(es.ServerVar('eventscripts_gamedir'))+'/'+demo_dir2):
					os.mkdir(str(es.ServerVar('eventscripts_gamedir'))+'/'+demo_dir2)
				if str(es.ServerVar("cw_demo_name")) != "":
					n=0
					if demo_name.startswith('%'):
						demo_name = " "+demo_name
						n=1
					if demo_name.find("%map"):
						demo_name = demo_name.replace('%map', str(es.ServerVar('eventscripts_currentmap')))
					if demo_name.find('%d'):
						demo_name = demo_name.replace('%d', str(time.strftime("%d", localtime())))
					if demo_name.find('%y'):
						demo_name = demo_name.replace('%y', str(time.strftime("%y", localtime())))
					if demo_name.find('%M'):
						demo_name = demo_name.replace('%M', str(time.strftime("%M", localtime())))
					if demo_name.find('%H'):
						demo_name = demo_name.replace('%H', str(time.strftime("%H", localtime())))
					if demo_name.find('%m'):
						demo_name = demo_name.replace('%m', str(time.strftime("%m", localtime())))
					if n==1:
						demoX = ""
						while n!= len(demo_name):
							demoX+= demo_name[n]
							n+=1
						demo_name = demoX
				if str(es.ServerVar("cw_demo_name")) == "":
					demo_name = str(es.ServerVar('eventscripts_currentmap'))+'_'+str(time.strftime("%d%m%y_%H%M", localtime()))
				demo_name_g = demo_name
				es.server.queuecmd("tv_record %s%s.dem"%(demo_dir1, demo_name))
				es.delayed(5, "es_msg #multi %s #green%s"%(cw_translation("demo_start", None, lang=str(es.ServerVar("cw_language"))), demo_name))
		if knives == "ON":
			gamethread.delayed(3, resetcounter_set, 0)
			knive_round()
			es.server.queuecmd("hostname %s %s"%(serv_name, cw_translation("hostname_knife", None, lang=str(es.ServerVar("cw_language"))))) 
		if knives == "OFF":
			gamethread.delayed(3, resetcounter_set, 2)
			resetcounter = 2
			es.msg("#multi", "#green[CW] #default%s"%cw_translation("tag", None, lang=str(es.ServerVar("cw_language"))))
			es.server.queuecmd('hostname "%s %s %s(%s) %s %s(%s)"'%(serv_name, cw_translation("hostname_live", lang=str(es.ServerVar("cw_language"))), teamA[0], teamA[6], cw_translation("hostname_vs", None, lang=str(es.ServerVar("cw_language"))), teamB[0], teamB[6]))
			for ply in playerlib.getPlayerList('#alive'):
				playerlib.getPlayer(ply.userid).freeze(0)
			live()
	if int(es.ServerVar("tv_enable")) == 1:
		if int(es.ServerVar("cw_Sourcetv_kick")) == 1:
			for ply in playerlib.getPlayerList('#spec'):
				if not es.isbot(ply.userid):
					if es.getplayersteamid(ply.userid) != 'BOT':
						if ((int(es.ServerVar("cw_not_kick_admins")) == 1) and (check_admin(ply.steamid) == 0)) or (int(es.ServerVar("cw_not_kick_admins")) == 0):
							SourceTV_kick(ply.userid)
	admin_menu.setoption("plugin_opts", "%s"%(cw_translation("adm_stop", None, lang=str(es.ServerVar("cw_language")))))
	for userid in es.getUseridList():
		if popuplib.isqueued('admin_menu', userid):
			admin_menu.unsend(userid)
			admin_menu.send(userid)
def player_spawn(ev):
	if started == 1:
		if knives == "ON":
			es.setplayerprop(ev['userid'], "CCSPlayer.m_iAccount", 100)
			es.server.queuecmd('es_xfire %s weapon_glock kill'%ev['userid'])
			es.server.queuecmd('es_xfire %s weapon_usp kill'%ev['userid'])
			es.server.queuecmd('es_xfire %s weapon_c4 kill'%ev['userid'])
			es.sexec(ev['userid'], 'use weapon_knife')
	if freezed == 1:
		playerlib.getPlayer(ev['userid']).freeze(1)
def round_start(ev):
	if started == 1:
		if knives == "ON":
			es.msg("#multi", "#green[CW] #default%s"%cw_translation("knives_on", None, lang=str(es.ServerVar("cw_language"))))
		elif resetcounter in [2,3,4,5]:
			if int(es.ServerVar("cw_show_cash")) == 1:
				cash = []
				for userid in es.getUseridList():
					if not es.isbot(userid):
						if es.getplayersteamid(userid) != 'BOT':
							cash.append((es.getplayername(userid), es.getplayerteam(userid), es.getplayerprop(userid, "CCSPlayer.m_iAccount")))
				for ply in sorted(cash, key=itemgetter(2), reverse=True):
					for users in es.getUseridList():
						if ply[1] == es.getplayerteam(users):
							if ply[2] < 10000:
								es.tell(users, "#multi", "#green[CW] #default%s$  >> #lightgreen%s"%(ply[2], ply[0]))
							elif ply[2] < 1000:
								es.tell(users, "#multi", "#green[CW] #default%s$   >> #lightgreen%s"%(ply[2], ply[0]))
							else:
								es.tell(users, "#multi", "#green[CW] #default%s$ >> #lightgreen%s"%(ply[2], ply[0]))
				while len(cash) > 0:
					cash.remove(cash[0])
	while len(aliveCT) > 0:
		aliveCT.remove(aliveCT[0])
	while len(aliveT) > 0:
		aliveT.remove(aliveT[0])
	while len(dead_ct_List) > 0:
		dead_ct_List.remove(dead_ct_List[0])
	while len(dead_t_List) > 0:
		dead_t_List.remove(dead_t_List[0])
def swap():
	if resetcounter > 1:
		if teamA[1] == "CT":
			teamA[1] = "T"
			teamB[1] = "CT"
		elif teamA[1] == "T":
			teamA[1] = "CT"
			teamB[1] = "T"
	for userid in es.getUseridList():
		if not es.isbot(userid):
			if es.getplayerprop(userid, "CBaseEntity.m_iTeamNum") in [2,3]:
				es.server.queuecmd('es_changeteam %s %s'%(userid, (5-es.getplayerprop(userid, "CBaseEntity.m_iTeamNum"))))
def freeze():
	global freezed
	freezed = 1
	for ply in playerlib.getPlayerList('#alive'):
		es.cexec(ply.userid, "playgamesound player\damage1.wav")
		playerlib.getPlayer(ply.userid).freeze(1)

def es_map_start(ev):
	if es.ServerVar("cw_mani_admins") == 1:
		ma.get_clients()
	get_admins()
	downloads()
	if started == 1:
		stop_match()

def weapon_fire(ev):
	if freezed == 1:
		if ev['weapon'] != 'knife':
			es.sexec(ev['userid'], 'drop')

def es_client_command(ev):
	if popuplib.isqueued('menu', ev['userid']):
		if ev['command'] == "menuselect":
			if ev['commandstring'] == "10":
				global freezed, reserved
				all_menu.unsend(PlayerList)
				menu.unsend(ev['userid'])
				es.cexec(ev['userid'], "playgamesound %s"%close)
				es.server.queuecmd("mp_restartgame 2")
				freezed = 0
				reserved = 0
def team_filter(userid, cmd):
	if cmd[0].lower() == 'jointeam':
		if started == 1:
			if str(es.getplayerteam(userid)) != cmd[1].lower():
				if cmd[1].lower() == '2':
					if len(playerlib.getPlayerList('#t,#human')) >= int(gameplay):
						es.tell(userid, '#multi', '#green%s' % cw_translation("t_full", None, lang=str(es.ServerVar("cw_language"))))
						return False
				elif cmd[1].lower() == '3':
					if len(playerlib.getPlayerList('#t,#human')) >= int(gameplay):
						es.tell(userid, '#multi', '#green%s' % cw_translation("ct_full", None, lang=str(es.ServerVar("cw_language"))))
						return False
				elif cmd[1].lower() == '1':
					if int(es.ServerVar("cw_spec_go_restrict")) == 1:
						if es.getplayerteam(userid) in [2,3]:
							es.tell(userid, '#multi', '#green%s' % cw_translation("spec_restrict", None, lang=str(es.ServerVar("cw_language"))))
							return False
		else:
			if int(es.ServerVar("cw_5player_limit")) == 1:
				if str(es.getplayerteam(userid)) != cmd[1].lower():
					if cmd[1].lower() == '2':
						if len(playerlib.getPlayerList('#t,#bot')) < 1:
							if int(es.getplayercount(2)) > 5:
								es.tell(userid, '#multi', '#green%s' % cw_translation("ct_full", None, lang=str(es.ServerVar("cw_language"))))
								return False
					elif cmd[1].lower() == '3':
						if len(playerlib.getPlayerList('#ct,#bot')) < 1:
							if int(es.getplayercount(3)) > 5:
								es.tell(userid, '#multi', '#green%s' % cw_translation("t_full", None, lang=str(es.ServerVar("cw_language"))))
								return False
	return True

def player_team(ev):
	if not es.isbot(ev['userid']):
		if es.getplayersteamid(ev['userid']) != 'BOT':
			if started == 1:
				if ev['team'] == '2':
					if ev['oldteam'] == '3':
						if ev['userid'] in dead_ct_List:
							dead_ct_List.remove(ev['userid'])
						if ev['userid'] not in dead_t_List:
							dead_t_List.append(ev['userid'])
				elif ev['team'] == '3':
					if ev['oldteam'] == '2':
						if ev['userid'] in dead_t_List:
							dead_t_List.remove(ev['userid'])
						if ev['userid'] not in dead_ct_List:
							dead_ct_List.append(ev['userid'])

			else:
				if int(es.ServerVar("cw_warmod_comtable")) == 1:
					if ev['team'] == '1':
						if ev['userid'] in readylist:
							readylist.remove(ev['userid'])
							es.tell(ev['userid'], '#multi', '#green[CW] %s'%cw_translation("were_removed_ready", None, lang=str(es.ServerVar("cw_language"))))
							rmenu()
					else:
						if ev['oldteam'] == '0':
							rmenu()

def reg_team_talk():
	es.addons.registerTickListener(team_talk)	
def unreg_team_talk():
	es.addons.unregisterTickListener(team_talk)
def player_death(ev):
	global aliveT, aliveCT
	if ev['es_userteam'] == "2":
		if not es.isbot(ev['userid']):
			if es.getplayersteamid(ev['userid']) != 'BOT':
				if ev['userid'] not in dead_t_List:
					dead_t_List.append(ev['userid'])
	if ev['es_userteam'] == "3":
		if not es.isbot(ev['userid']):
			if es.getplayersteamid(ev['userid']) != 'BOT':
				if ev['userid'] not in dead_ct_List:
					dead_ct_List.append(ev['userid'])
	aliveCT = (playerlib.getUseridList('#ct, #alive, #human'))
	aliveT = (playerlib.getUseridList('#t, #alive, #human'))
	
def team_talk():
	if (len(dead_t_List) > 0) and (len(aliveT) > 0):
		for userid in dead_t_List:
			for userid2 in aliveT:
				es.voicechat('listen', userid2, userid)
	if (len(dead_ct_List) > 0) and (len(aliveT) > 0):
		for userid in dead_ct_List:
			for userid2 in aliveCT:
				es.voicechat('listen', userid2, userid)

def player_activate(ev):
	if started == 1:
		if int(es.ServerVar("tv_enable")) == 1:
			if int(es.ServerVar("cw_Sourcetv_kick")) == 1:
				if not es.isbot(ev['userid']):
					if es.getplayersteamid(ev['userid']) != 'BOT':
						if ((int(es.ServerVar("cw_not_kick_admins")) == 1) and (check_admin(ev['es_steamid']) == 0)) or (int(es.ServerVar("cw_not_kick_admins")) == 0):
							if (gameplay != 0) and ((len(playerlib.getPlayerList('#human'))) > (gameplay*2)):
								SourceTV_kick(ev['userid'])

def SourceTV_kick(userid):
	if es.exists('userid', userid):
		if es.ServerVar('ip') == "localhost":
			if es.ServerVar('cw_Sourcetv_ip'):
				es.server.queuecmd("kickid %s %s: %s:%s" % (userid, cw_translation("STV_kick", None, lang=str(es.ServerVar("cw_language"))), es.ServerVar('cw_Sourcetv_ip'), es.ServerVar('tv_port')))
			else:
				es.server.queuecmd("kickid %s %s Server_IP:%s" % (userid, cw_translation("STV_kick", None, lang=str(es.ServerVar("cw_language"))), es.ServerVar('tv_port')))
		else:
			es.server.queuecmd("kickid %s %s %s:%s" % (userid, cw_translation("STV_kick", None, lang=str(es.ServerVar("cw_language"))), es.ServerVar('ip'), es.ServerVar('tv_port')))

